
#include <math.h>


double kl1 (double *p,double *pp, int sizep) {

	int i;
	double sump, sumpp, sumprob;
	double pd[5], ppd[5], subp[5], prob[5];

	sump = 0;
	sumpp = 0;
	sumprob = 0;
	
	/* add a small value to avoid log(0) error*/
	for(i=0; i<sizep; i++){
		p[i] = p[i]+0.0001;
		sump += p[i];
		pp[i] = pp[i]+0.0001;
		sumpp += pp[i];
	}

	/* normalize each value, find logarithimic difference (similar to ratio)
	   find out the prob and return cumalitive number at the end */
	for(i=0; i < sizep; i++) {
		p[i]= p[i]/sump;
		pp[i] = pp[i]/sumpp;
		pd[i] = log(p[i]);
		ppd[i] = log(pp[i]);
		subp[i] = ppd[i] - pd[i];
		prob[i] = p[i]*subp[i];
		sumprob += prob[i];
	}
	
	return sumprob;
	
}
