entity idct_tb is
end;

library IEEE;
use IEEE.STD_LOGIC_1164.all;

--library xil_idct_v1_00_a;
--use xil_idct_v1_00_a.idct_core;


architecture BENCH of idct_tb is

  component XIL_IDCT_v1_00_a is
    generic (
    C_DWIDTH      : integer := 32
  );
  port (
    -- Global signals
    Clk   : in std_logic;
    Reset : in std_logic;

    -- Slave FSL Signals
    FSL_S_Clk     : out std_logic;
    FSL_S_Read    : out std_logic;
    FSL_S_Data    : in  std_logic_vector(0 to C_DWIDTH-1);
    FSL_S_Control : in  std_logic;
    FSL_S_Exists  : in  std_logic;

    -- Master FSL Signals
    FSL_M_Clk     : out std_logic;
    FSL_M_Write   : out std_logic;
    FSL_M_Data    : out std_logic_vector(0 to C_DWIDTH-1);
    FSL_M_Control : out std_logic;
    FSL_M_Full    : in  std_logic
    );

  end component XIL_IDCT_v1_00_a;

  signal FSL_S_Data, FSL_M_Data: STD_LOGIC_VECTOR(0 to 31);
  signal Clk, Reset, FSL_S_Exists, FSL_S_Read, FSL_M_Full, FSL_M_Write,
     FSL_S_Clk, FSL_S_Control, FSL_M_Clk, FSL_M_Control : STD_LOGIC;

begin

  Clk <= '0', '1' after 100 NS, '0' after 200 NS, '1' after 300 NS, '0' after 400 NS,
    '1' after 500 NS, '0' after 600 NS, '1' after 700 NS;
    
  --FSL_S_Data <= '01010101010';
  FSL_S_Exists <= '1';  

  idc: XIL_IDCT_v1_00_a port map (Clk, Reset, FSL_S_Clk, FSL_S_Read, FSL_S_Data,
    FSL_S_Control, FSL_S_Exists, FSL_M_Clk, FSL_M_Write, FSL_M_Data,
    FSL_M_Control,FSL_M_Full);

end BENCH;
