--This is the vhdl code for the RGB/Greyscale converter

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

library unisim;
use unisim.all;
use UNISIM.VCOMPONENTS.ALL; 


entity iDCT is
  port (
    Clk            : in  std_logic;
    Reset          : in  std_logic;
    Data_In        : in  std_logic_vector(23 downto 0);
    Data_In_Valid  : in  std_logic;
    Read_Data_In   : out std_logic;
    Data_Out_Full  : in  std_logic;
    Data_Out       : out std_logic_vector(23 downto 0);
    Data_Out_Valid : out std_logic);
end entity iDCT;


architecture IMP of iDCT is

--declaring states of finite state machine for FSL operation
type state IS (IDLE,READ,WRITE,WRITE_FIN);
signal op: state;
   begin
      Downloading : process (Clk, Reset)
	 --declaring variables for mask filter
	 variable tmp: std_logic_vector(7 downto 0);
 	 variable tmp2: std_logic_vector(7 downto 0);
	 variable tmp3: std_logic_vector(7 downto 0);
      begin

		--initializing finite state machine for FSL operation
	 	if Reset='1'	then 
    			Read_Data_In   <= '0';
    			Data_Out <= "000000000000000000000000";
    			Data_Out_Valid <= '0';
			op <= IDLE;
	   	elsif Clk ='1' then
			case op is
				when IDLE =>
					   Read_Data_In <= '0';
					   Data_Out_Valid <= '0';
					--if there is data to be read, set op to READ
					--else remain at IDLE
				 	if(Data_In_Valid = '1') then
						op <= READ;
						-- tmp := Data_In;
					else
						op <= IDLE;
					end if;
				--after reading in data set op to WRITE
				when READ =>
					Read_Data_In <= '1';
					op <= WRITE;	
				--while writing data, perform mask filtering operation on the first and
				--last eight bits eliminating both red and blue from an image and leaving
				--only green
				when WRITE =>
					Read_Data_In <= '0';
					tmp:= "00000000";
					tmp2 := Data_In(15 downto 8);
					tmp3:= "00000000";
					Data_Out <= tmp & tmp2 & tmp3;
					op <= WRITE_FIN;
				--Wait for the write to finish before resetting op to IDLE
				when WRITE_FIN =>
					Data_Out_Valid <= '1';
					op <= IDLE;
			end case;
		end if;
	  end process Downloading;
end architecture IMP;


